package com.becan.pi.audio;

import java.util.LinkedList;

public class Buffer {

	private int size;
	private int chunkSize;

	private LinkedList<byte[]> dataFree = new LinkedList<byte[]>();
	private LinkedList<byte[]> data = new LinkedList<byte[]>();

	public Buffer(int size, int chunkSize) {
		this.size = size;
		this.chunkSize = chunkSize;
		init();
	}

	private void init() {
		int chunks = size / chunkSize;
		for (int i = 0; i < size / chunkSize; i++) {
			byte[] chunk = new byte[chunkSize];
			pushFree(chunk);
		}
		size = chunks * chunkSize;
	}

	public void push(byte[] chunk) {
		data.addFirst(chunk);
	}

	public byte[] pop() throws Exception {
		if (data.size() == 0)
			throw new Exception("Internal buffer underflow");
		return data.removeLast();
	}

	public void pushFree(byte[] chunk) {
		dataFree.addFirst(chunk);
	}

	public byte[] popFree() throws Exception {
		if (dataFree.size() == 0)
			throw new Exception("Internal buffer overflow");
		return dataFree.removeLast();
	}

}
